{
  Objeto...: Biblioteca para operaes com teclado.
  Categoria: Open-Source
  Autor....: Daniel Pereira Guimares
  E-mail...: tecnobyte@ulbrajp.com.br
  Home-Page: www.ulbrajp.com.br/~tecnobyte
  Reviso..: 21 de Fevereiro de 2001
}

unit tbKeybd;

interface

uses Windows;

{ Retorna true se CapsLock ligado }
function  tbGetCapsLock: boolean;
{ Retorna true se NumLock ligado }
function  tbGetNumLock: boolean;
{ Simula - pressionar tecla }
procedure tbKeyDown(const Key: integer);
{ Retorna true se a tecla est pressionada }
function  tbKeyIsDown(const Key: integer): boolean;
{ Simula - soltar tecla }
procedure tbKeyUp(const Key: integer);
{ Altera o estado de CapsLock: ligado/desligado }
procedure tbSetCapsLock(const State: boolean);
{ Altera o estado de NumLock: ligado/desligado }
procedure tbSetNumLock(const State: boolean);

implementation

function tbGetCapsLock: boolean;
begin
  Result := GetKeyState(VK_CAPITAL) and 1 <> 0;
end;

function tbGetNumLock: boolean;
begin
  Result := GetKeyState(VK_NUMLOCK) and 1 <> 0;
end;

procedure tbKeyDown(const Key: integer);
begin
  keybd_event(Key, 0, 0, 0);
end;

function tbKeyIsDown(const Key: integer): boolean;
begin
  Result := GetKeyState(Key) and 128 <> 0;
end;

procedure tbKeyUp(const Key: integer);
begin
  keybd_event(Key, 0, KEYEVENTF_KEYUP, 0);
end;

procedure tbSetCapsLock(const State: boolean);
var
  KeyState: TKeyboardState;
begin
  GetKeyboardState(KeyState);
  if State then
    { Ativa o bit zero }
    KeyState[VK_CAPITAL] := KeyState[VK_CAPITAL] or 1
  else
    { Desativa o bit zero }
    KeyState[VK_CAPITAL] := KeyState[VK_CAPITAL] and 254;
  SetKeyboardState(KeyState);
end;

procedure tbSetNumLock(const State: boolean);
var
  KeyState: TKeyboardState;
begin
  GetKeyboardState(KeyState);
  if State then
    { Ativa o bit zero }
    KeyState[VK_NUMLOCK] := KeyState[VK_NUMLOCK] or 1
  else
    { Desativa o bit zero }
    KeyState[VK_NUMLOCK] := KeyState[VK_NUMLOCK] and 254;
  SetKeyboardState(KeyState);
end;

end.
